
#    Note:  This is loaded into the namespace  MEISAPS

# variable started 0

#Analyser.Current+             : -a=0x00009000 -c3 -g=1 -q=u -u=A -d=0 -r=0x0000:0uA,0x0fff:1000uA
#Analyser.Current-             : -a=0x00009000 -c4 -g=1 -q=u -u=A -d=0 -r=0x0000:0uA,0x0fff:1000uA
#Analyser.Energy               : -a0x00008000 -o0x00000088 -w16 -d16 -ud -mn -prw -qk -teV -n3 \
#                                    -r0x0:0.000keV,0xffff:416.667keV -i0.000keV
#Analyser.Power                : -a0x00008000 -o0x0000008a -w16 -d8 -ud -mn -prw -l1 -b0 -i0 -zd -s0
#Analyser.Volts+               : -a=0x00009000 -c1 -g=1 -q=k -u=V -d=2 -r=0x0000:0.00kV,0x0fff:25.00kV
#Analyser.Volts-               : -a=0x00009000 -c2 -g=1 -q=k -u=V -d=2 -r=0x0000:0.00kV,0x0fff:25.00kV

#xvme560   0x9000
#xvme240   0x8000


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Blue
    set Color2(1) #D4A017     ;# Orange Gold

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    variable OFF 1
    variable ON 0

    variable Offset0 0.0kV
    variable Offset1 0
    variable Offset2 0
    variable Offset3 0
    variable Offset4 0

   proc  show_variables {} {
       variable OFF
       variable ON
       variable Offset0
       variable Offset1
       variable Offset2
       variable Offset3
       variable Offset4
     
   set registerList [list  Analyser.Energy  Analyser.Volts+  Analyser.Volts-  Analyser.Current+  Analyser.Current- Analyser.Power]

       InsertLog "$OFF $ON $Offset0 $Offset1 $Offset3 $Offset3 $Offset4"

      foreach register $registerList {
         InsertLog "$register => [ReadMEISRegister $register]"
      }
   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }

   proc do_Setting {w reg vl} {     ;#InsertLog "Setting $w $reg $vl"
       variable Offset0

#    Offset0 => Analyser.Energy      note  -  sliders do not return units for analogue registers
#     all other sliders are monitors (read only)

      set $w$reg $vl  ;# save in the Offset* variables

     switch $reg {
        0     {set Offset0 [set vl]kV; WriteMEISRegister Analyser.Energy $Offset0}
        default {}
     }
   }

   proc do_Power {vl} {    ;#InsertLog "Run $vl"
      variable OFF
      variable ON

       switch $vl {
         0 {
            set OFF 1
            set ON 0
            WriteMEISRegister Analyser.Power 0
         }
         1 {
            set OFF 0
            set ON 1
            WriteMEISRegister Analyser.Power 1
         }
         default {}
       }
   }

    proc UpdateModule {} {
       variable Offset0
       variable Offset1
       variable Offset2
       variable Offset3
       variable Offset4

#    Offset0 => Analyser.Energy
#    Offset1 => Analyser.Volts+
#    Offset2 => Analyser.Volts-
#    Offset3 => Analyser.Current+
#    Offset4 => Analyser>Current-

       variable ON
       variable OFF

         if {[expr [ReadMEISRegister Analyser.Power] & 1] == 0} {set ON 0; set OFF 1} else {set ON 1; set OFF 0}
         set Offset0 [ReadMEISRegister Analyser.Energy]

         set Offset1 [ReadMEISRegister Analyser.Volts+]
         set Offset2 [ReadMEISRegister Analyser.Volts-]
         set Offset3 [ReadMEISRegister Analyser.Current+]
         set Offset4 [ReadMEISRegister Analyser.Current-]
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   SETTING {do_Setting [second [lindex $cgidata 1]] [third [lindex $cgidata 1]] [fourth [lindex $cgidata 1]]}
                   POWER   {do_Power [second [lindex $cgidata 1]]}

                   REDISPLAY {UpdateModule}
                   UPDATE    {UpdateModule}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateModule
     }
     UpdateModule

}   ;# end of if {$started == 0}




