
#    Note:  This is loaded into the namespace  MEIS

#variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    variable NumReg 0


   proc  show_variables {} {


   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }
     
      proc do_Activate {} {
        global errorCode errorInfo
        variable NumReg
      
        InsertLog "Activating new MEIS Configuration"

        set rc [DeleteNETRegisters "*"]
        InsertLog "Delete returns $rc"

        set NumReg 0

        set z [catch {source MEIS.defn.tcl} msg]
        if {$z != 0} {Alert "Problem creating MEIS registers\n$msg"}

        InsertLog "MEIS Configuration created"

        InsertLog "Activating new VME Configuration"

        set rc [catch {Inform VMEConfig do_Restore} m]
        InsertLog "VMEConfig Restore returns $rc $m"
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }

        set rc [catch {Inform VMEConfig do_Activate} m]
        InsertLog "VMEConfig Activate return $rc $m"

        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }

        InsertLog "Initialise VME registers"

        set rc [catch {Inform VMEConfig InitialiseVMERegisters "*"} m]
        InsertLog "VMEConfig Initialise returns $rc $m"
        if {$rc != 0} {
           set rc $errorCode
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }

    }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}
                   Activate {do_Activate}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

}   ;# end of if {$started == 0}




