
#    Note:  This is loaded into the namespace  MEISO

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Blue
    set Color2(1) #D4A017     ;# Orange Gold

    variable BT0 0
    variable BT1 0
    variable BT2 0
    variable BT3 0
    variable BT4 1
    variable BT5 0
    variable BT6 1
    variable BT7 0
    variable BT8 1
    variable BT9 0
    variable BT10 0
    variable BT11 0
    variable BT12 0

    variable ADC0 999
    variable ADC1 999
    variable ADC2 999
    variable ADC3 999

    variable CH#0 12
    variable CH#1 8
    variable CH#2 4
    variable CH#3 0

    variable Offset0 0
    variable Offset1 0
    variable Offset2 0
    variable Offset3 0


   proc  show_variables {} {
    variable Offset0
    variable Offset1
    variable Offset2
    variable Offset3

    variable BT0

       InsertLog "Offsets:  $Offset0 $Offset1 $Offset2 $Offset3"
       InsertLog "BT0=[set BT0]"

   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingMEISDataAcq}

          default {}
       }

       do_help
   }

   proc do_Button {w} {    ;InsertLog "Button $w"
     for {set i 0} {$i <=12} {incr i} {variable BT$i}
     for {set i 0} {$i <=3} {incr i} {variable CH#$i}

#   Button 0=> 3   ADC channel enables
#          4&5     FC controls
#          6&7     2D rotation scan Stop/Start
#          8&9         Up/Down
#          10      test histogram enable
#          11      auto-save

       switch $w {
          0  -
          1  -
          2  -
          3  {set adc [set CH#[set w]]; set BT$w [expr [set BT$w]^1]; WriteVMERegister v785#1.Disable$adc [expr [set BT$w]^1]}
          4 -
          5  {set BT4 [expr $BT4^1]; set BT5 [expr $BT5^1]}
          6 -
          7  {set BT6 [expr $BT6^1]; set BT7 [expr $BT7^1]}
          8 -
          9  {set BT8 [expr $BT8^1]; set BT9 [expr $BT9^1]}
          10  {set BT10 [expr $BT10^1]}
          11  {set BT11 [expr $BT11^1]}
         default {}
       }
   }

   proc do_Channel {w vl} {    ;InsertLog "Channel $w $vl"

      variable CH#[set w]; set CH#[set w] $vl
   }

   proc do_Setting {w reg vl} {     ;InsertLog "Setting $w $reg $vl"

#    Offset0 => ADC Threshold for Corner A  etc

      set $w$reg $vl  ;# save in the Offset* variables

      variable CH#[set reg]
      set adc [set CH#[set reg]]   ;#  ADC channel for this corner

     switch $reg {
        0 -
        1 -
        2 -
        3     {WriteVMERegister v785#1.Threshold$adc $vl}
        default {}
     }
   }

   proc UpdateModule {} {

        foreach w {0 1 2 3} {
           variable CH#[set w]
           set adc [set CH#[set w]]   ;#  ADC channel for this corner
           variable Offset$w; set Offset$w [ReadVMERegister v785#1.Threshold$adc]
        }

        foreach w {0 1 2 3} {
           variable CH#[set w]
           set adc [set CH#[set w]]   ;#  ADC channel for this corner
           variable BT$w; set BT$w [expr ([ReadVMERegister v785#1.Disable$adc] & 1)^1]
        }

}


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   BUTTON   {do_Button [second [lindex $cgidata 1]]}
                   CH       {do_Channel [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   SETTING  {do_Setting [second [lindex $cgidata 1]] [third [lindex $cgidata 1]] [fourth [lindex $cgidata 1]]}

                   REDISPLAY {}
                    UPDATE    {}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        UpdateModule
     }
     UpdateModule

}   ;# end of if {$started == 0}




